//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "mainform.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxCPU2kVcl"
#pragma resource "*.dfm"
Td_DemoMain *d_DemoMain;
//---------------------------------------------------------------------------
__fastcall Td_DemoMain::Td_DemoMain(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall Td_DemoMain::Button1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall Td_DemoMain::FormCreate(TObject *Sender)
{
  PageControl1->ActivePage = TabSheet1;
  if (Screen->Fonts->IndexOf("Tahoma") != (-1))
    Font->Name = "Tahoma";
  Panel1->Font->Name = Font->Name;
  Panel2->Font->Name = Font->Name;
  Panel3->Font->Name = Font->Name;
  Panel4->Font->Name = Font->Name;
  Panel5->Font->Name = Font->Name;

  // Processor details
  lblName->Caption = cxCpu->FullName;
  lblVendor->Caption = cxCpu->Vendor;
  lblSpeed->Caption = String(cxCpu->Speed) + " Mhz";
  lblSerial->Caption = cxCpu->Serial;
  if (bool(cxCpu->FDivBug))
    lblFDiv->Caption = "Present";
  else
    lblFDiv->Caption = "Not Present";
  if (bool(cxCpu->OverDrive))
    lblType->Caption = "OverDrive Processor";
  else
    lblType->Caption = "OEM or Retail Processor";

  if (bool(cxCpu->MMX))
    lblMMX->Caption = "MMX Instructions Supported";
  else
    lblMMX->Caption = "MMX Instructions not supported";

  if (bool(cxCpu->FeatureSet->SIMD))
    lblSIMD->Caption = "SIMD Instructions Supported";
  else
    lblSIMD->Caption = "SIMD Instructions not supported";

  if (bool(cxCpu->FeatureSetEx->AMD3DNow))
    lbl3DNow->Caption = "3DNow! Instructions Supported";
  else
    lbl3DNow->Caption = "3DNow! Instructions not supported";

  lblL1Code->Caption = String(cxCpu->Cache->L1Code) + " Kb";
  lblL1Data->Caption = String(cxCpu->Cache->L1Data) + " Kb";
  lblLevel1->Caption = String(cxCpu->Cache->Level1) + " Kb";
  lblLevel2->Caption = String(cxCpu->Cache->Level2) + " Kb";

  // Feature Set
  FeatureList->Items->BeginUpdate();
  AddFeature("FPU", "Floating Point Processor", cxCpu->FeatureSet->FPU);
  AddFeature("VME", "Virtual Mode Extension", cxCpu->FeatureSet->VME);
  AddFeature("DE", "Debugging Extension", cxCpu->FeatureSet->DE);
  AddFeature("PSE", "Page Size Extension", cxCpu->FeatureSet->PSE);
  AddFeature("TSC", "Time Stamp Counter", cxCpu->FeatureSet->TSC);
  AddFeature("MSR", "Model Specific Registers", cxCpu->FeatureSet->MSR);
  AddFeature("PAE", "Physical Address Extension", cxCpu->FeatureSet->PAE);
  AddFeature("MCE", "Machine Check Exception", cxCpu->FeatureSet->MCE);
  AddFeature("CX8", "CMPXCHG8 Instruction", cxCpu->FeatureSet->CX8);
  AddFeature("APIC", "On-chip APIC Hardware", cxCpu->FeatureSet->APIC);
  AddFeature("SEP", "Fast System Call", cxCpu->FeatureSet->SEP);
  AddFeature("MTRR", "Memory Type Range Registers", cxCpu->FeatureSet->MTRR);
  AddFeature("PGE", "Page Global Enable", cxCpu->FeatureSet->PGE);
  AddFeature("MCA", "Machine Check Architecture", cxCpu->FeatureSet->MCA);
  AddFeature("CMOV", "Conditional Move Instruction", cxCpu->FeatureSet->CMOV);
  AddFeature("PAT", "Page Attribute Table", cxCpu->FeatureSet->PAT);
  AddFeature("PSE36", "36-bit Page Size Extension", cxCpu->FeatureSet->PSE36);
  AddFeature("SERIAL", "Processor Serial Number", cxCpu->FeatureSet->SERIAL);
  AddFeature("CLFLUSH", "CLFLUSH Instruction", cxCpu->FeatureSet->CLFLUSH);
  AddFeature("DTS", "Debug Trace Store", cxCpu->FeatureSet->DTS);
  AddFeature("ACPI", "Advanced Configuration and Power Management Interface", cxCpu->FeatureSet->ACPI);
  AddFeature("MMX", "MMX Extensions", cxCpu->FeatureSet->MMX);
  AddFeature("FXSR", "Floating Point Save and Restore", cxCpu->FeatureSet->XSR);
  AddFeature("SIMD", "Streaming SIMD Extensions", cxCpu->FeatureSet->SIMD);
  AddFeature("SIMD2", "Streaming SIMD Extensions 2", cxCpu->FeatureSet->SIMD2);
  AddFeature("SS", "Self-Snoop", cxCpu->FeatureSet->SS);
  AddFeature("TM", "Thermal Monitor Supported", cxCpu->FeatureSet->TM);

  AddFeature("3DNOW", "3DNow! Extensions", cxCpu->FeatureSetEx->AMD3DNow);
  AddFeature("3DNOWEX", "Enhanced 3DNow! Extensions", cxCpu->FeatureSetEx->AMD3DNowEx);
  AddFeature("MMXEX", "Enhanced MMX Extensions", cxCpu->FeatureSetEx->MMXEx);

  //FeatureList->SortType = stText;
  FeatureList->Items->EndUpdate();

  // About Information
  lblVclVersion->Caption = "CarbonSoft cxCpu Vcl Component version " +
                           String(cxCpu->VersionInfo->VCL->Version) +
                           " (Build " + (cxCpu->VersionInfo->VCL->Build) + ")";
  lblApiVersion->Caption = "CarbonSoft cxCpu Detection API version " +
                           String(cxCpu->VersionInfo->API->Version) +
                           " (Build " + (cxCpu->VersionInfo->API->Build) + ")";
}
//---------------------------------------------------------------------------

void __fastcall Td_DemoMain::AddFeature(char *name,char *description, bool present)
{
  TListItem  *ListItem;

  ListItem = FeatureList->Items->Add();
  ListItem->ImageIndex = !(present);
  ListItem->Caption = name;
  ListItem->SubItems->Add(description);
}
//---------------------------------------------------------------------------
void __fastcall Td_DemoMain::Label15Click(TObject *Sender)
{
  ShellExecute(Handle, "open", "http://www.carbonsoft.com", "", "", SW_NORMAL);
}
//---------------------------------------------------------------------------
